/* $Id: d_mos2.h,v 18.15 2000/09/01 02:05:04 al Exp $ -*- C++ -*-
 * mos model equations: spice level 2 equivalent
 */
/* This file is automatically generated. DO NOT EDIT */
#ifndef D_MOS2_H_INCLUDED
#define D_MOS2_H_INCLUDED

#include "d_mos123.h"
/*--------------------------------------------------------------------------*/
class SDP_MOS2
  :public SDP_MOS123{
public:
  explicit SDP_MOS2(const COMPONENT_COMMON*);
public:
  double relxj;	// 
  double eta_1;	// 
  double eta;	// 
  double eta_2;	// 
};
/*--------------------------------------------------------------------------*/
class TDP_MOS2
  :public TDP_MOS123{
public:
  explicit TDP_MOS2(const DEV_MOS*);
public:
  double vt;	// 
  double phi;	// 
  double sqrt_phi;	// 
  double phi_sqrt_phi;	// 
  double beta;	// 
  double uo;	// 
  double vbi;	// 
};
/*--------------------------------------------------------------------------*/
class MODEL_MOS2
  :public MODEL_MOS123{
public:
  // using generated copy constructor, should be unreachable
  explicit MODEL_MOS2();
  ~MODEL_MOS2() {--_count;}
public: // override virtual
  bool          parse_front(CS&);
  void          parse_params(CS&);
  void          post_parse();
  SDP_CARD* new_sdp(const COMPONENT_COMMON* c)const {return new SDP_MOS2(c);}
  void          print_front(OMSTREAM&)const;
  void          print_params(OMSTREAM&)const;
  void          print_calculated(OMSTREAM&)const;
  void          tr_eval(COMPONENT*)const;
public: // not virtual
  static int    count() {return _count;}
public: // strictly internal
  enum {LEVEL=2};
  static int _count;
public: // input parameters

  double kp;	// transconductance parameter
  double nfs;	// fast surface state density
  double vmax;	// max drift velocity of carriers
  double neff;	// total channel charge coefficient
  double ucrit;	// critical field mobility degradation
  double uexp;	// critical field exponent in mob.deg.
  double utra;	// transverse field coefficient (not used)
  double delta;	// width effect on threshold voltage
public: // calculated parameters
  bool calc_kp;	// 
  double alpha;	// 
  double xd;	// coeffDepLayWidth
  double xwb;	// 
  double vbp;	// 
  double cfsox;	// 
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
